/* Copyright 2020 Pascal Grafe - MIT License */
'use strict';

spimosimCore.modules.add('Network', {
    name: 'barabasi-albert-lattice-vis',
    files: [ 'lib/modules/Network/barabasi-albert-lattice-vis.js' ],
    depends: ['module:Network/barabasi-albert'],
    version: '1.0',
    author: 'Pascal Grafe',
    description: 'A network generated by the barabasi albert algorithm to be visualized on a lattice.',
    date: '2020-03-26'
  }, {
    parameters: [ 'sqrtn', 'm' ],
    calculateNetworkSize: function (settings) {
      return settings.network.sqrtn * settings.network.sqrtn;
    },
    generateAdjacencyLists: function (settings) {
      settings.n = settings.sqrtn * settings.sqrtn;
      return spimosimCore.modules.get('Network', 'barabasi-albert').generateAdjacencyLists(settings);
    }
});
